Index: /palm/trunk/SOURCE/average_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/average_3d_data.f90	(revision 3003)
+++ /palm/trunk/SOURCE/average_3d_data.f90	(revision 3004)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Further allocation checks implemented, case z0q* added
+! 
+! 2885 2018-03-14 11:02:46Z Giersch
 ! Preliminary gust module interface implemented
 ! 
@@ -201,314 +204,398 @@
 
           CASE ( 'e' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      e_av(k,j,i) = e_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( e_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         e_av(k,j,i) = e_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'ghf*' )
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   ghf_av(j,i) = ghf_av(j,i)                                   &
-                                 / REAL( average_count_3d, KIND=wp )
-                ENDDO
-             ENDDO
-             CALL exchange_horiz_2d( ghf_av, nbgp )
+             IF ( ALLOCATED( ghf_av ) ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      ghf_av(j,i) = ghf_av(j,i)                                   &
+                                    / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+                CALL exchange_horiz_2d( ghf_av, nbgp )
+             ENDIF
 
           CASE ( 'qsws*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   qsws_av(j,i) = qsws_av(j,i) / REAL( average_count_3d, KIND=wp )
-                ENDDO
-             ENDDO
-             CALL exchange_horiz_2d( qsws_av, nbgp )
+             IF ( ALLOCATED( qsws_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      qsws_av(j,i) = qsws_av(j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+                CALL exchange_horiz_2d( qsws_av, nbgp )
+             ENDIF
 
           CASE ( 'lpt' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      lpt_av(k,j,i) = lpt_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( lpt_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         lpt_av(k,j,i) = lpt_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'lwp*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   lwp_av(j,i) = lwp_av(j,i) / REAL( average_count_3d, KIND=wp )
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( lwp_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      lwp_av(j,i) = lwp_av(j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'nc' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      nc_av(k,j,i) = nc_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( nc_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         nc_av(k,j,i) = nc_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'nr' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      nr_av(k,j,i) = nr_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( nr_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         nr_av(k,j,i) = nr_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
          CASE ( 'ol*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   ol_av(j,i) = ol_av(j,i) / REAL( average_count_3d, KIND=wp )
-                ENDDO
-             ENDDO
-             CALL exchange_horiz_2d( ol_av, nbgp )
+             IF ( ALLOCATED( ol_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      ol_av(j,i) = ol_av(j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+                CALL exchange_horiz_2d( ol_av, nbgp )
+             ENDIF
 
           CASE ( 'p' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      p_av(k,j,i) = p_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( p_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         p_av(k,j,i) = p_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'pc' )
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1
-                      pc_av(k,j,i) = pc_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( pc_av ) ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         pc_av(k,j,i) = pc_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'pr' )
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1
-                      pr_av(k,j,i) = pr_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
-
-          CASE ( 'prr*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   precipitation_rate_av(j,i) = precipitation_rate_av(j,i) /   &
-                                                REAL( average_count_3d, KIND=wp )
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( pr_av ) ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         pr_av(k,j,i) = pr_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+          CASE ( 'prr' )
+             IF ( ALLOCATED( prr_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         prr_av(k,j,i) = prr_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'pt' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      pt_av(k,j,i) = pt_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( pt_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         pt_av(k,j,i) = pt_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'q' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      q_av(k,j,i) = q_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( q_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         q_av(k,j,i) = q_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'qc' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      qc_av(k,j,i) = qc_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( qc_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         qc_av(k,j,i) = qc_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'ql' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      ql_av(k,j,i) = ql_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( ql_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         ql_av(k,j,i) = ql_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'ql_c' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      ql_c_av(k,j,i) = ql_c_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( ql_c_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         ql_c_av(k,j,i) = ql_c_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'ql_v' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      ql_v_av(k,j,i) = ql_v_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( ql_v_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         ql_v_av(k,j,i) = ql_v_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'ql_vp' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      ql_vp_av(k,j,i) = ql_vp_av(k,j,i) /                      &
-                                        REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( ql_vp_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         ql_vp_av(k,j,i) = ql_vp_av(k,j,i) /                      &
+                                           REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'qr' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      qr_av(k,j,i) = qr_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( qr_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         qr_av(k,j,i) = qr_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'qv' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      qv_av(k,j,i) = qv_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( qv_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         qv_av(k,j,i) = qv_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
          CASE ( 'r_a*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   r_a_av(j,i) = r_a_av(j,i) / REAL( average_count_3d, KIND=wp )
-                ENDDO
-             ENDDO
-             CALL exchange_horiz_2d( r_a_av, nbgp )
+             IF ( ALLOCATED( r_a_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      r_a_av(j,i) = r_a_av(j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+                CALL exchange_horiz_2d( r_a_av, nbgp )
+             ENDIF
 
           CASE ( 'rho_ocean' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      rho_ocean_av(k,j,i) = rho_ocean_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( rho_ocean_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         rho_ocean_av(k,j,i) = rho_ocean_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 's' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      s_av(k,j,i) = s_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( s_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         s_av(k,j,i) = s_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'sa' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      sa_av(k,j,i) = sa_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( sa_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         sa_av(k,j,i) = sa_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
          CASE ( 'shf*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   shf_av(j,i) = shf_av(j,i) / REAL( average_count_3d, KIND=wp )
-                ENDDO
-             ENDDO
-             CALL exchange_horiz_2d( shf_av, nbgp )
+             IF ( ALLOCATED( shf_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      shf_av(j,i) = shf_av(j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+                CALL exchange_horiz_2d( shf_av, nbgp )
+             ENDIF
 
           CASE ( 'ssws*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   ssws_av(j,i) = ssws_av(j,i) / REAL( average_count_3d, KIND=wp )
-                ENDDO
-             ENDDO
-             CALL exchange_horiz_2d( ssws_av, nbgp )
+             IF ( ALLOCATED( ssws_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      ssws_av(j,i) = ssws_av(j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+                CALL exchange_horiz_2d( ssws_av, nbgp )
+             ENDIF
 
           CASE ( 't*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   ts_av(j,i) = ts_av(j,i) / REAL( average_count_3d, KIND=wp )
-                ENDDO
-             ENDDO
-             CALL exchange_horiz_2d( ts_av, nbgp )
+             IF ( ALLOCATED( ts_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      ts_av(j,i) = ts_av(j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+                CALL exchange_horiz_2d( ts_av, nbgp )
+             ENDIF
 
          CASE ( 'tsurf*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   tsurf_av(j,i) = tsurf_av(j,i) / REAL( average_count_3d, KIND=wp )
-                ENDDO
-             ENDDO
-             CALL exchange_horiz_2d( tsurf_av, nbgp )
+             IF ( ALLOCATED( tsurf_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      tsurf_av(j,i) = tsurf_av(j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+                CALL exchange_horiz_2d( tsurf_av, nbgp )
+             ENDIF
 
           CASE ( 'u' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      u_av(k,j,i) = u_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( u_av ) ) THEN 
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         u_av(k,j,i) = u_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'u*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   us_av(j,i) = us_av(j,i) / REAL( average_count_3d, KIND=wp )
-                ENDDO
-             ENDDO
-             CALL exchange_horiz_2d( us_av, nbgp )
+             IF ( ALLOCATED( us_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      us_av(j,i) = us_av(j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+                CALL exchange_horiz_2d( us_av, nbgp )
+             ENDIF
 
           CASE ( 'v' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      v_av(k,j,i) = v_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( v_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         v_av(k,j,i) = v_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'vpt' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      vpt_av(k,j,i) = vpt_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( vpt_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         vpt_av(k,j,i) = vpt_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'w' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      w_av(k,j,i) = w_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( w_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         w_av(k,j,i) = w_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'z0*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   z0_av(j,i) = z0_av(j,i) / REAL( average_count_3d, KIND=wp )
-                ENDDO
-             ENDDO
-             CALL exchange_horiz_2d( z0_av, nbgp )
+             IF ( ALLOCATED( z0_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      z0_av(j,i) = z0_av(j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+                CALL exchange_horiz_2d( z0_av, nbgp )
+             ENDIF
 
           CASE ( 'z0h*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   z0h_av(j,i) = z0h_av(j,i) / REAL( average_count_3d, KIND=wp )
-                ENDDO
-             ENDDO
-             CALL exchange_horiz_2d( z0h_av, nbgp )
+             IF ( ALLOCATED( z0h_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      z0h_av(j,i) = z0h_av(j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+                CALL exchange_horiz_2d( z0h_av, nbgp )
+             ENDIF
+
+          CASE ( 'z0q*' )
+             IF ( ALLOCATED( z0q_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      z0q_av(j,i) = z0q_av(j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+                CALL exchange_horiz_2d( z0q_av, nbgp )
+             ENDIF
+
 !             
 !--       Block of urban surface model outputs   
Index: /palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3003)
+++ /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3004)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! Comment concerning averaged data output added 
+! 
+! 2932 2018-03-26 09:39:22Z maronga
 ! renamed chemistry_par to chemistry_parameters
 ! 
@@ -1219,5 +1222,11 @@
 ! Description:
 ! ------------
-!> Subroutine for averaging 3D data of chemical species
+!> Subroutine for averaging 3D data of chemical species. Due to the fact that 
+!> the averaged chem arrays are allocated in chem_init, no if-query concerning
+!> the allocation is required (in any mode). Attention: If you just specify an 
+!> averaged output quantity in the _p3dr file during restarts the first output
+!> includes the time between the beginning of the restart run and the first
+!> output time (not necessarily the whole averaging_interval you have 
+!> specified in your _p3d/_p3dr file )
 !------------------------------------------------------------------------------!
 
